<template>
  <q-layout view="hHh LpR fFf">
    <q-header
      bordered
      class="text-white"
      height-hint="98"
      :class="{ 'bg-dark': $q.dark.isActive }"
    >
      <q-toolbar>
        <q-btn
          flat
          dense
          round
          @click="drawerLeft = !drawerLeft"
          icon="menu"
          aria-label="Menu"
        />

        <q-toolbar-title class="full-width ellipsis">
          {{ title }}
        </q-toolbar-title>
        <q-icon
          v-if="!isSynced && !isOnline"
          name="sync_problem"
          color="red"
          size="24px"
          left
        >
          <q-tooltip>Невозможно синхронизировать </q-tooltip>
        </q-icon>
        <q-icon
          v-else-if="isSynced"
          name="sync"
          color="green"
          size="24px"
          left
          @click="onClickSyncBtn"
        >
          <q-tooltip>Синхронизировано </q-tooltip>
        </q-icon>
        <q-icon
          v-else
          name="sync_disabled"
          color="yellow"
          size="24px"
          left
          @click="onClickSyncBtn"
        >
          <q-tooltip>Не синхронизировано </q-tooltip>
        </q-icon>
        <q-icon v-if="isOnline" name="power" size="24px" left>
          <q-tooltip>Онлайн </q-tooltip>
        </q-icon>
        <q-icon v-else name="power_off" color="red" size="24px" left>
          <q-tooltip>Офлайн </q-tooltip>
        </q-icon>
        <q-select
          v-model="lang"
          :options="langs"
          class="row"
          color="primary"
          :bg-color="$q.dark.isActive ? 'black' : 'white'"
          filled
          dense
          options-dense
          outlined
        />
        <q-btn
          round
          dense
          :icon="$q.dark.isActive ? 'light_mode' : 'mode_night'"
          @click="$q.dark.toggle"
        />
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="drawerLeft"
      show-if-above
      :width="200"
      :breakpoint="400"
      :overlay="$q.screen.lt.sm"
      bordered
    >
      <q-img
        v-if="isLoggedIn"
        class="absolute-top"
        :src="getCover"
        style="height: 150px"
      >
        <div class="bg-transparent flex flex-center column full-width">
          <q-avatar size="64px" class="q-mb-sm">
            <img
              alt="Аватара пользователя"
              :src="userAvatar"
              @error="
                () => {
                  fallbackUserAvatar = getFallbackAvatar;
                }
              "
            />
          </q-avatar>
          <div class="text-weight-bold full-width ellipsis">
            {{ currentUser.first_name }} {{ currentUser.last_name }}
          </div>
          <div class="text-caption full-width">{{ currentUser.id }}</div>
        </div>
      </q-img>

      <q-scroll-area
        style="height: calc(100% - 150px); border-right: 1px solid #ddd"
        :style="{
          'margin-top': isLoggedIn ? '150px' : '',
          height: isLoggedIn ? 'calc(100% - 150px)' : '100%',
        }"
      >
        <q-list padding>
          <!-- exact - выделять цветом, если это текущий маршрут -->
          <q-item
            :exact="false"
            clickable
            v-ripple
            :to="{ path: '/carts', query: $route.query }"
          >
            <q-item-section avatar>
              <q-icon name="list" />
            </q-item-section>

            <q-item-section> {{ $t('Lists') }} </q-item-section>
          </q-item>

          <q-item
            :to="{ path: '/help', query: $route.query }"
            exact
            clickable
            v-ripple
          >
            <q-item-section avatar>
              <q-icon name="help" />
            </q-item-section>

            <q-item-section> {{ $t('Help') }} </q-item-section>
          </q-item>

          <q-separator />

          <q-item
            v-if="isLoggedIn"
            exact
            clickable
            v-ripple
            @click="showLogoutDialog = true"
          >
            <q-item-section avatar>
              <q-icon name="logout" />
            </q-item-section>

            <q-item-section> {{ $t('Logout') }} </q-item-section>
          </q-item>

          <q-item
            v-else
            exact
            clickable
            v-ripple
            @click="showLoginDialog = true"
          >
            <q-item-section avatar>
              <q-icon name="login" />
            </q-item-section>

            <q-item-section> {{ $t('Login') }} </q-item-section>
          </q-item>
        </q-list>
      </q-scroll-area>
    </q-drawer>

    <q-page-container class="main-page-container">
      <router-view v-slot="{ Component, route }">
        <transition name="fade">
          <component :is="Component" :key="route.path" />
        </transition>
      </router-view>
    </q-page-container>
    <q-dialog v-model="showLoginDialog">
      <login />
    </q-dialog>
    <q-dialog v-model="showLogoutDialog">
      <logout />
    </q-dialog>
  </q-layout>
</template>

<i18n>

</i18n>

<script lang="ts">
// https://datatracker.ietf.org/doc/html/draft-ietf-oauth-browser-based-apps
import { defineComponent } from 'vue';
import { useCurrentUserStore } from 'src/stores/current-user';
import { mapActions, mapState } from 'pinia';
import { debugLog } from '../utils';
import { LocalStorage } from 'quasar';
import { useAllCartsStore } from 'src/stores/all-carts';

import Login from 'src/components/Login.vue';
import Logout from 'src/components/Logout.vue';
import { useNetworkStore } from 'src/stores/network';

export default defineComponent({
  name: 'MainLayout',
  components: { Login: Login, Logout: Logout },
  data() {
    return {
      fallbackUserAvatar: null,
      drawerLeft: false,
      langs: ['RU', 'EN'],
      lang: null,
      showLoginDialog: false,
      showLogoutDialog: false,
    };
  },
  watch: {
    lang(lang) {
      this.$i18n.locale = lang.toLowerCase().slice(0, 2);
      LocalStorage.set('locale', this.$i18n.locale);
      import('src/i18n/').then((language) => {
        this.$q.lang.set(language.default[this.$i18n.locale]);
      });
    },
    '$q.dark.isActive': function (val) {
      LocalStorage.set('dark', val);
    },
  },

  methods: {
    ...mapActions(useNetworkStore, ['setOnlineStatus']),
    ...mapActions(useAllCartsStore, {
      syncCarts: 'syncCarts',
      initCarts: 'initCarts',
    }),
    onClickSyncBtn() {
      this.syncCarts();
    },
  },
  computed: {
    ...mapState(useCurrentUserStore, [
      'currentUser',
      'getAvatar',
      'getCover',
      'getFallbackAvatar',
      'isLoggedIn',
    ]),
    ...mapState(useNetworkStore, ['isOnline']),

    ...mapState(useAllCartsStore, {
      cartName: function (state) {
        return state.getRouteName(+this.$route.params.id);
      },
      isSynced: 'isSynced',
    }),

    userAvatar() {
      return this.fallbackUserAvatar || this.getAvatar;
    },
    title() {
      if ('id' in this.$route.params) return this.cartName;
      return this.$t(this.$route.name);
    },
    selectedLangOption() {
      return this.$i18n.locale;
    },
  },
  created() {
    debugLog('MainLayout Component Created');

    //FIXME: временное решение по добавлению провайдера в idb
    this.$idb.saveProviderByUrl({
      provider_url: process.env.PROD
        ? 'https://cart.universo.pro'
        : 'http://127.0.0.1:3000',
    });

    // Здесь this.$route инициализирован.
    //экспериментальный слушатель для сервисворкера
    navigator.serviceWorker.addEventListener('message', (event) => {
      if (event.data.type === 'CACHE_UPDATED') {
        const { updatedURL } = event.data.payload;
        console.log(`A newer version of ${updatedURL} is available!`);
      }
    });
  },
  mounted() {
    debugLog('MainLayout Component Mounted');
    this.initCarts();

    // Здесь this.$route инициализирован.
    window.addEventListener('online', () => this.setOnlineStatus(true));
    window.addEventListener('offline', () => this.setOnlineStatus(false));

    navigator.serviceWorker.addEventListener('message', (event) => {
      debugLog('Сервисворкер слышит: ', event);

      if (event.data === 'new-version-available') {
        // Показать уведомление пользователю и предложить перезагрузить страницу

        debugLog('Сервисворкер обновлён');
        window.location.reload();
      }
    });

    //инициализируем dark из локали
    const dark = LocalStorage.getItem('dark') || false;
    this.$q.dark.set(dark);

    //инициализация локали
    const locale = LocalStorage.getItem('locale') || null;
    if (typeof locale === 'string') {
      //берём только первые два символа локали
      this.$i18n.locale = locale
        ? locale.toLowerCase().slice(0, 2)
        : this.$q.lang.getLocale().toLowerCase().slice(0, 2);
      this.lang = this.$i18n.locale.toUpperCase();
      import('src/i18n/').then((language) => {
        this.$q.lang.set(language.default[this.$i18n.locale]);
      });
    }
  },
});
</script>
